var Main = (function () {
	var lastDegree = 0;	
	var startTimer = {
		left: false //left Stick
	};
	var duration = {
		left: 100 //left Stick
	};

	var isSnap = {
		left: true //left Stick
	};
    
    var getSnapDegree = function(degree, otherDegree, stride) {
        var curSnapDegree = Math.floor(degree/stride)*stride;
        if(curSnapDegree === otherDegree)
            return degree;
        else {
            var deadDegreeZone = 3;
            if(Math.abs(degree - otherDegree) < deadDegreeZone)
                return degree;
            return curSnapDegree;
        }
    }
  
	var updateLeftStick = function(){
		if((Gamepad.getLeftStick().fx || Gamepad.getLeftStick().fy) && startTimer.left === false)
		{
			var degree = Gamepad.getLastLeftAngle();
			degree = degree + 90;
			degree = Math.fmod(degree + 360, 360);
            
            //snap 
            if(isSnap.left) {
                var snapDegree = getSnapDegree(degree, lastDegree, 90);
                if(snapDegree === degree)
                    return;
                degree = snapDegree;
            }
            
			//print degree			
			showText(id_debug_degree, degree);
			
			var el = document.getElementById('arrow_rot');
			el.style.opacity = "0.5";		
			
			var start = Date.now();
			startTimer.left = true;
			var timer = setInterval(function() {
				let timePassed = Date.now() - start;

				if (timePassed >= duration.left) {
					clearInterval(timer);
					lastDegree = degree;
					el.style.transform = 'rotate(' + String(degree) + 'deg)';
					startTimer.left = false;
					el.style.opacity = "1";
					return;
				}

				move(timePassed);
			}, 20);	

			function move(timePassed) {
				var diff = degree - lastDegree;
				if(diff > 180)
					diff = -(360 - diff);
				if(diff < -180)
					diff = 360 + diff;
				
				var currDeg = lastDegree + diff * timePassed/duration.left;
				currDeg = Math.fmod(currDeg + 360, 360);
				el.style.transform = 'rotate(' + String(currDeg) + 'deg)';
			}
		}
	};

	var updateGamepad = function(){
		if(Gamepad.click(GamepadKey.A)) 
			showText('id_debug_key', 'pressd A key' );
		if(Gamepad.click(GamepadKey.B)) 
			showText('id_debug_key', 'pressd B key' );		
		else
			updateLeftStick();
		
		//x, y is 0 or 1.
		//move by left Stick, Digital pad key
		var x = Gamepad.moveClick().x;
		var y = Gamepad.moveClick().y;
		if(x || y) {
			var str = 'moveClick x' + x + ', y:' + y;  
			showText('id_debug_move', str);
		}
	}
	
	var listenForGamepad = function () {
		updateLoop = function () {
			Gamepad.preUpdate();
			updateGamepad();
			Gamepad.postUpdate();
			requestAnimationFrame(updateLoop);
		};
		updateLoop();
	};

	function addGamepadEvent() {
		window.addEventListener("gamepadconnected", function (e) {
			Gamepad.init();
			listenForGamepad();
		});
	}

    var showText = function(element, str) {
		if(typeof element === 'string')
			element = document.getElementById(element);

		element.textContent = str;	
		return element;
	}
	
    var moveTo = function(element) {
		if(typeof element === 'string')
			element = document.getElementById(element);

		element.style.left =  element.offsetLeft - (element.offsetWidth)/2 + 'px';
		element.style.top =  element.offsetTop - element.offsetHeight/2 + 'px';		
		return element;
	}
	
    function init() {
		moveTo('arrow_rot');
		moveTo('box_id1');
		moveTo('box_id2');
		addGamepadEvent();
    }

    return {
        init: init,
    };
})();